import java.util.ArrayList;
import java.util.List;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.Queue;
import javax.jms.QueueConnection;
import javax.jms.QueueConnectionFactory;
import javax.jms.QueueReceiver;
import javax.jms.QueueSender;
import javax.jms.QueueSession;
import javax.jms.Session;
import javax.jms.TextMessage;

import org.apache.activemq.ActiveMQConnectionFactory;

public class Server {
    private static final String SERVER = "tcp://localhost:61616";
    private static final String UN = "arne";
    private static final String PW = "topsecret";
    private static final String QC2S = "QC2S";
    private static final String QS2C = "QS2C";
    private List<String> msgs = new ArrayList<String>();
    private void run() {
        try {
            // connect
            QueueConnectionFactory qcf = new ActiveMQConnectionFactory(SERVER);
            QueueConnection con = qcf.createQueueConnection(UN, PW);
            con.start();
            QueueSession ses = con.createQueueSession(false, Session.AUTO_ACKNOWLEDGE);
            Queue qc2s = ses.createQueue(QC2S);
            Queue qs2c = ses.createQueue(QS2C);
            QueueReceiver recv = ses.createReceiver(qc2s);
            QueueSender send = ses.createSender(qs2c);
            // loop indefinitely
            while(true) {
                // receive message and add to all messages
                TextMessage rmsg = (TextMessage)recv.receive();
                msgs.add(rmsg.getText().replaceAll("[\r\n]", ""));
                // send all messages
                StringBuilder sb = new StringBuilder();
                for(String msg : msgs) {
                    if(sb.length() > 0) sb.append("\r\n");
                    sb.append(msg);
                }
                Message smsg = ses.createTextMessage(sb.toString());
                send.send(smsg);
            }
        } catch (JMSException e) {
            e.printStackTrace();
        }
    }
    public static void main(String[] args) {
        Server srv = new Server();
        srv.run();
    }
}
